<template>
  <div>
    <b-breadcrumb class="py-1 pl-2" :items="breadcrumbs"></b-breadcrumb>
    <b-card class="h-100">
      <!-- <pre>{{ getDatosProyectos }}</pre> -->
      <!-- <pre>{{ items }}</pre> -->
      <b-card-title>
        <b-row align-h="between">
          <b-col cols="auto"> Proyectos </b-col>
          <b-col cols="auto">
            <b-button
              @click="abrirForm"
              variant="success"
              size="sm"
              class="mr-1"
            >
              <b-icon icon="plus"></b-icon>
              Crear
            </b-button>
          </b-col>
        </b-row>
      </b-card-title>
      <!-- User Interface controls -->
      <Table
      :keyTable="keyTable"
        :filter="filter"
        :items="items"
        :title="'Proyectos'"
        :fields="fields"
        :totalRows="getDatosProyectos.total"
        @mostarItem="mostarItem"
        @editarItem="editarItem"
        @eliminarItem="eliminarItem"
        @searchOrShortOrPage="listar"
      ></Table>

      <b-modal hide-footer :id="infoModal.id" :title="infoModal.title" ok-only>
        <Form
          v-if="infoModal.title"
          title="Partner Editor"
          :schema="schema"
          :model="item"
          @guardarForm="guardarForm"
          @actualizarForm="actualizarForm"
          @cerrarForm="cerrarForm"
        >
        </Form>
      </b-modal>
    </b-card>
  </div>
</template>

<script>
import Table from "../../components/table.vue";
import Form from "../../components/Form.vue";
import Swal from "sweetalert2";
import moment from "moment";
import { mapGetters } from "vuex";
import _ from "lodash";
import {
  LISTAR_PROYECTOS,
  GUARDAR_PROYECTO,
  MOSTRAR_PROYECTO,
  ACTUALIZAR_PROYECTO,
} from "../../store/modules/proyecto.module";

export default {
  components: {
    Table,
    Form,
  },
  data() {
    return {
      filter: { search: "", perPage: 10, sortBy: "id", currentPage: 1 },
      keyTable: Number(moment.unix),
      breadcrumbs: [
         {
          text: "Inicio",
          to: { name: "Inicio" },
          active: false,
        },
        {
          text: "Proyectos",
          href: "#",
          active: true,
        },
      ],
      fields: [
        {
          key: "id",
          label: "#",
          sortable: true,
          // sortDirection: "asc",
          class: "text-center",
        },
        {
          key: "nombre",
          label: "Nombre",
          sortable: true,
          class: "text-center",
        },
        {
          key: "codigo",
          label: "Codigo",
          sortable: true,
          class: "text-center",
        },
        {
          key: "gestion",
          label: "Gestion",
          sortable: true,
          class: "text-center",
        },
        {
          key: "created_at",
          label: "Creado",
          sortable: true,
          formatter: (value) => {
            return value ? moment(value).format("DD-MM-YYYY H:mm:ss") : "";
          },
          class: "text-center",
        },
        {
          key: "updated_at",
          label: "Actualizado",
          sortable: true,
          formatter: (value) => {
            return value ? moment(value).format("DD-MM-YYYY H:mm:ss") : "";
          },
          class: "text-center",
        },
        // {
        //   key: "isActive",
        //   label: "Is Active",
        //   formatter: (value) => {
        //     return value ? "Yes" : "No";
        //   },
        //   sortable: true,
        //   sortByFormatted: true,
        //   filterByFormatted: true,
        // },

        { key: "acciones", label: "acciones", class: "text-center" },
      ],
      schema: {
        fields: [
          {
            type: "text",
            name: "nombre",
            label: "Nombre",
            placeholder: "Ingrese el nombre",
            _validate: {
              required: true,
            },
          },
          {
            type: "text",
            name: "codigo",
            label: "Codigo",
            placeholder: "Ingrese el codigo",
            _validate: {
              required: true,
            },
          },
          {
            type: "text",
            name: "gestion",
            label: "gestion",
            placeholder: "Ingrese la gestion",
            _validate: {
              required: true,
            },
          },
        ],
      },
      item: {
        id: null,
        nombre: "",
        codigo: "",
        gestion: "",
      },
      infoModal: {
        id: "info-modal",
        title: "",
        content: "",
      },
    };
  },
  computed: {
    ...mapGetters(["getDatosProyectos", "getProyecto"]),
    items() {
      return _.map(this.getDatosProyectos.data, (proyecto) => {
        return (proyecto = {
          ...proyecto,
          acciones: {
            mostrar: {
              name: "mostrar",
              label: "Mostrar",
              show: false,
              color: "primary",
            },
            editar: {
              name: "editar",
              label: "Editar",
              show: true,
              color: "warning",
            },
            eliminar: {
              name: "eliminar",
              label: "Eliminar",
              show: false,
              color: "danger",
            },
          },
        });
        // .acciones=[
        //   {
        //     name:"Mostar",
        //   }
        // ]
      });
    },
  },
  mounted() {
    // Set the initial number of items
    this.totalRows = this.items.length;
    this.listar();
  },
  methods: {
    listar() {
      let data = {
        search: this.filter.search ?? "",
        per_page: this.filter.perPage ?? 10,
        sort_by: this.filter.sortBy ?? "id",
        page: this.filter.currentPage ?? 1,
      };
      console.log("ddddddddddddddddddddddddd",data);
      this.$store.dispatch(LISTAR_PROYECTOS, data).then(() => {
        this.keyTable++;
      });
    },
    vaciarItem() {
      this.item = {
        id: null,
        nombre: "",
        codigo: "",
        gestion: "",
      };
    },
    abrirForm: function () {
      this.infoModal.title = "Nuevo proyecto";
      this.vaciarItem();
      this.$root.$emit("bv::show::modal", this.infoModal.id);
    },
    guardarForm: async function (data) {
      console.log(data);
      try {
        this.$store
          .dispatch(GUARDAR_PROYECTO, data)
          .then(() => this.cerrarForm())
          .catch((e) => {
            console.log("eeeeeeeeeeeeeeeee", e);
          });
      } catch (e) {
        console.log("eeeeeeeeeeeeeeeee", e);
        Swal.fire("Error!", e, "error");
      }
    },
    actualizarForm: async function (data) {
      console.log(data);
      try {
        this.$store
          .dispatch(ACTUALIZAR_PROYECTO, data)
          .then(() => this.cerrarForm())
          .catch((e) => {
            console.log("eeeeeeeeeeeeeeeee", e);
          });
      } catch (e) {
        console.log("eeeeeeeeeeeeeeeee2", e);

        Swal.fire("Error!", e, "error");
      }
    },
    cerrarForm: function () {
      this.infoModal.title = "";
      this.item = {
        id: null,
        nombre: "",
        codigo: "",
        gestion: "",
      };
      this.$root.$emit("bv::hide::modal", this.infoModal.id);
    },
    mostarItem(id) {
      // this.$dispatch(SHOW_PROYECTO, { id });
      this.infoModal.title = "Mostrar proyecto";
      // this.vaciarItem();
      this.$root.$emit("bv::show::modal", this.infoModal.id);
    },
    editarItem(id) {
      this.$store.dispatch(MOSTRAR_PROYECTO, { id }).then(() => {
        this.infoModal.title = "Editar proyecto";
        this.item = this.getProyecto;
        // this.vaciarItem();
        this.$root.$emit("bv::show::modal", this.infoModal.id);
      });
    },
    eliminarItem(id) {
      // this.$dispatch(_PROYECTO,id)
    },
  },
};
</script>